SystemOrganization addCategory: #'GT-InspectorExtensions-Core'!

!ContextPart methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 6/25/2014 23:13'!
gtInspectorVariableValuePairs
	"We override the variables with context specific ones"
	| tempIndex |
	tempIndex := 0.
	^ super gtInspectorVariableValuePairs
		addAll:
				(self tempNames
						collect: [ :tempName ||value|
							tempIndex := tempIndex + 1.
							value := [self debuggerMap namedTempAt: tempIndex in: self] 
								on: Error 
								do: [value := (Text string: 'error obtaining field value' attribute: TextColor red) asString ].
							('[' , tempName , ']') -> value ]);
		yourself! !

!FileReference class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/2/2014 21:11'!
gtExampleDirectory
	<gtExample>
	| directory subDirectory |
	directory := FileSystem memory workingDirectory / 'directory'.
	directory createDirectory.
	directory / 'file1.txt' writeStreamDo: [ :stream | stream nextPutAll: 'File1 contents' ].
	directory / 'file2.txt' writeStreamDo: [ :stream | stream nextPutAll: 'File2 contents' ].
	subDirectory := (directory / 'subdirectory') createDirectory.
	subDirectory / 'file3.txt' writeStreamDo: [ :stream | stream nextPutAll: 'File3 contents' ].
	^ directory! !

!FileReference class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/2/2014 22:14'!
gtExampleGif
	<gtExample>
	^ FileSystem memory workingDirectory / 'pharoicon.gif' 
		writeStreamDo: [ :stream |
			GIFReadWriter 
				putForm: ThemeIcons current pharoIcon 
				onStream: stream ];
		yourself! !

!FileReference class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/2/2014 22:13'!
gtExamplePng
	<gtExample>
	^ FileSystem memory workingDirectory / 'pharoicon.png' 
		writeStreamDo: [ :stream |
			PNGReadWriter 
				putForm: ThemeIcons current pharoIcon 
				onStream: stream ];
		yourself! !

!FileReference class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/2/2014 20:22'!
gtExampleText
	<gtExample>
	^ FileSystem memory workingDirectory / 'sample.txt' 
		writeStreamDo: [ :stream |
			stream nextPutAll: self comment ];
		yourself! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/28/2014 06:40'!
gtInspectorActionMaterializeFuel
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ :composite | 
			| result |
			result := FLMaterializer materializeFromFileNamed: self fullName.
			composite selection: result ];
		icon: GLMUIThemeExtraIcons glamorousAdd;
		condition: [ self extension = 'fuel' ];
		title: 'Materialize'! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/16/2014 00:11'!
gtInspectorContentsIn: composite
	<gtInspectorPresentationOrder: 10>
	composite rubricText
			title: 'Raw';
			display: [ 
				self readStreamDo: [ :stream | 
					| result |
					result := [(stream next: 10000) asString]
						on: Error 
						do: [ (stream binary next: 10000) asString ].
					stream size > 10000
						ifTrue: [ result, '  ... truncated ...' ]
						ifFalse: [ result ] ] ];
			withLineNumbers: true;
			when: [ self isFile ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'MaxLeske 3/4/2014 11:57'!
gtInspectorFuelIn: composite
	<gtInspectorPresentationOrder: 40>
	"(FileSystem disk workingDirectory / 'GTtest.fuel') writeStreamDo: [ :stream |
	FLSerializer newDefault
		at: #author putAdditionalObject: 'Author: Max Leske';
		at: #date putAdditionalObject: DateAndTime now;
		addPreMaterializationAction: [ Smalltalk inform: 'starting materialization' ];
		addPostMaterializationAction: [ :materialization | materialization inspect ];
		serialize: 'foo' on: stream binary ].
	
FLMaterializer materializeFromFileNamed: 'GTtest.fuel'"
	composite table
			title: 'Fuel Header';
			display: [
				(FLMaterializer materializeHeaderFromFileNamed: self fullName) gtGetMetaData ];
			column: 'Property' evaluated: [:assoc| assoc key ];
			column: 'Value' evaluated: [:assoc| assoc value];
			when: [ self extension = 'fuel' ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/14/2014 17:04'!
gtInspectorGifIn: composite
	<gtInspectorPresentationOrder: 10>
	composite morph
			title: 'Picture';
			display: [ self binaryReadStreamDo: [ :stream | GIFReadWriter formFromStream: stream ] ];
			when: [ self mimeTypes notNil and: [ self mimeTypes first matches: ZnMimeType imageGif ] ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/22/2014 20:52'!
gtInspectorGroupedFilesIn: composite
	<gtInspectorPresentationOrder: 40>
	^ composite graphET
		title: 'Grouped files';
		diagram: [ :renderer :presentation |
			| metric all grouped diag diag2|
			metric := #size.
			all := self allFiles.
			grouped := (all groupedBy: [ :each | each extension ]) 
								associations sorted: [:a :b | 
											(a value sumNumbers: metric) > 
											(b value sumNumbers: metric) ].
			grouped := (grouped first: (20 min: grouped size)) select: [:each | (each value sumNumbers: metric) > 0].
			diag := (GETHorizontalBarDiagram new)
				xAxisLabel: 'Number of files';
				modelLabels: [:each | each key ];
				x: [:each | each value size];
				valueAxis;
				color: Color veryLightGray;
				axisColor: Color veryLightGray;
				on: ROMouseClick do: [:event | presentation selection: event model value ];
				models: grouped.
			diag2 := (GETHorizontalBarDiagram new)
				xAxisLabel: 'Total size in MB';
				x: [:each | (each value sumNumbers: metric) / 1000000];
				regularAxis;
				xAxisOnTop;
				gapFraction: 1 / 2;
				color: (Color red);
				axisColor: (Color red);
				on: ROMouseClick do: [:event | presentation selection: event model value ];
				models: grouped.
			(renderer unionDiagram)
				add: diag;
				add: diag2 ];
				when: [self isDirectory and: [self hasChildren]]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 8/5/2014 14:44'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: 40>
	^ composite table 
		title: 'Items';
		display: [ 
			| children |
			children := self directories, self files.
			self isRoot 
				ifTrue: [ children ]
				ifFalse: [ 
					children asOrderedCollection 
						addFirst: self parent;
						yourself ] ];
		column: 'Name' evaluated: [:each | (self isChildOf: each) 
								ifTrue: [ '..' ] 
								ifFalse: [ each basename ]] width: 400;
		column: 'Size' evaluated: [:each | each humanReadableSize] width: 100;
		column: 'Creation' evaluated: [ :each | 
			String streamContents: [:s | 
				each creationTime printYMDOn: s.
				s nextPut: Character space.
				each creationTime printHMSOn: s ]];
		icon: [ :each | 
			each isDirectory 
				ifTrue: [ GLMUIThemeExtraIcons glamorousFolder ] 
				ifFalse: [ GLMUIThemeExtraIcons glamorousBrowse ] ];
		when: [self isDirectory and: [self hasChildren]];
		selectionAct: [:table | table selection delete. table update] entitled: 'Delete'! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/14/2014 17:04'!
gtInspectorJpegIn: composite
	<gtInspectorPresentationOrder: 10>
	composite morph
			title: 'Picture';
			display: [ self binaryReadStreamDo: [ :stream | JPEGReadWriter formFromStream: stream ] ];
			when: [ self mimeTypes notNil and: [ self mimeTypes first matches: ZnMimeType imageJpeg ] ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/14/2014 17:04'!
gtInspectorPngIn: composite
	<gtInspectorPresentationOrder: 10>
	composite morph
			title: 'Picture';
			display: [ self binaryReadStreamDo: [ :stream | PNGReadWriter formFromStream: stream ] ];
			when: [ self mimeTypes notNil and: [ self mimeTypes first matches: ZnMimeType imagePng ] ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 8/1/2014 23:50'!
gtInspectorStScriptIn: composite
	<gtInspectorPresentationOrder: 40>
	composite smalltalkCode
			title: 'Script';
			display: [ self readStreamDo: [ :s | s contents ] ];
			selectionPopulate: #selection
				on: $o
				entitled: 'Do it and open (o)'
				with: [ :text :object | 
					Compiler evaluate: text selectedText for: object logged: false ];
			act: [ :text |
				self ensureDelete; writeStreamDo: [ :s | s nextPutAll: text text asString ] ]
				icon: GLMUIThemeExtraIcons glamorousSave
				on: $s
				entitled: 'Save';
			when: [ self extension = 'st' ]! !

!GLMTabulator class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/25/2014 08:21'!
gtExampleSimple
	<gtExample>
	^ GLMTabulator new 
		with: [ :t |
			t column: #one.
			t transmit to: #one; andShow: [ :a | a text] ];
		startOn: 42! !

!String class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/28/2014 23:05'!
gtInspectorFourtyTwo
	<gtExample>
	^ '42'! !

!String methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/21/2013 22:44'!
gtInspectorItemsIn: composite
	"No items presentation for a String"! !

!String methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/22/2013 00:30'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: 30>  
	 composite text
		title: 'String'! !

!MCPackageManager class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/21/2014 13:09'!
gtInspectorManagersIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Managers';
		display: [ self allManagers sorted: [ :x :y | x packageName < y packageName ] ];
		format: #packageName;
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ]! !

!FileSystem class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/7/2014 07:51'!
gtExampleZip
	<gtExample>
	| zipFile zip |
	zipFile := FileSystem memory workingDirectory / 'test.zip'.
	zip := (FileSystem zip: zipFile) open.
	zip / 'sample.txt'
		writeStreamDo: [ :stream |
				stream nextPutAll: self comment ];
			yourself.
	^ zip! !

!FileSystem methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/7/2014 05:36'!
gtInspectorRootItemsIn: composite
	<gtInspectorPresentationOrder: 40>
	(self root gtInspectorItemsIn: composite)
		title: 'Root directory'! !

!FileSystem methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/7/2014 05:36'!
gtInspectorWorkingDirectoryItemsIn: composite
	<gtInspectorPresentationOrder: 40>
	(self workingDirectory gtInspectorItemsIn: composite)
		title: 'Working directory'! !

!ComposableModel methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/2/2013 16:38'!
gtInspectorModelNestingIn: composite
	<gtInspectorPresentationOrder: 20>
	composite tree 
		title: 'Nesting';
		display: [ :root | { 'root' -> self } ];
		children: [ :each | 
			each value class allInstVarNames 
				collect: [ :iv | iv->(each value instVarNamed: iv) ]
				thenSelect: [ :association | 
					(association value isKindOf: ComposableModel) 
						and: [ (#('owner' 'window') includes: association key) not ] ] ];
		format: [ :association | association key , ': ' , association value asString ];
		send: #value! !

!ComposableModel methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/3/2013 17:49'!
gtInspectorSpecIn: composite
	<gtInspectorPresentationOrder: 30>
	composite spec 
		title: 'Preview';
		when: [ self widget notNil ]! !

!Bitmap methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 8/22/2011 11:49'!
gtInspectorItemsIn: composite
	"No items presentation for a Bitmap"! !

!FLHeader methodsFor: '*GT-InspectorExtensions-Core' stamp: 'MaxLeske 3/4/2014 11:55'!
gtGetMetaData
	|assoc|
	
	assoc := OrderedCollection new.
	assoc add: ('Meta' ->(String streamContents: [ :stream |
		additionalObjects do: [ :add | add printOn: stream. stream crlf ]])).
	assoc add: ('Pre materialization actions:' -> (String streamContents: [ :stream |
		preMaterializationActions do: [ :action | action printOn: stream ]])).
	assoc add: ('Post materialization actions: ' -> (String streamContents: [ :stream |
		postMaterializationActions do: [ :action | action printOn: stream ]])).
	^ assoc! !

!Morph methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/6/2014 14:19'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 95>
	self kmDispatcher gtInspectorMappingsIn: composite! !

!Morph methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/27/2014 20:31'!
gtInspectorMorphExtensionIn: composite
	<gtInspectorPresentationOrder: 15>
	^ composite table
		title: 'Extension';
		showOnly: 50; 
		display: [ self extension gtInspectorVariableValuePairs asSortedCollection ];
		column: 'Variable' 
			evaluated: [:assoc | GTObjectPrinter new asNonTruncatedTextFrom: assoc key ];
		column: 'Value' 
			evaluated: [:assoc | GTObjectPrinter new asTruncatedTextFrom: assoc value ];
		send: #value;
		morphicSelectionAct: [:list | list selection value browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			on: $b 
			entitled: 'Browse';
		morphicSelectionAct: [:list | list selection value inspect ] 
			icon: GLMUIThemeExtraIcons glamorousInspect 
			on: $i 
			entitled: 'Inspect';
		selectionAct: [:list | 
			((list selection pointersToExcept: { list selection })
									reject: [ :each | each pointsOnlyWeaklyTo: list selection ]) inspect ] 
			on: $t
			entitled: 'Open pointers to'! !

!Morph methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/28/2014 10:25'!
gtInspectorMorphIn: composite
	<gtInspectorPresentationOrder: 90>  
	| morphPresentation |
	morphPresentation := composite morph.
	morphPresentation 
		title: 'Morph';
		display: [ :each |
			self imageForm asMorph
				on: #mouseDown send: #value: to: [ :event | 
					morphPresentation selection: (self morphsAt: event position) ] ];
		act: [ :pres | self exportAsPNG ] entitled: 'Export as PNG';
		act: [ :pres | self delete ] entitled: 'Delete'! !

!Morph methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/2/2012 03:22'!
gtInspectorSubmorphsIn: composite
	<gtInspectorPresentationOrder: 80>  
	composite tree 
		title: 'Submorphs';
		rootsExpanded;
		display: [:each | {each} ];
		icon: [:each | | morphForm |
			morphForm := each imageForm.
			(morphForm extent x > 0 and: [morphForm extent y > 0 ])
				ifTrue: [(morphForm scaledToSize: 16@16) asMorph]
				ifFalse: [Form extent: 16@16] ];
		children: [:each | each submorphs];
		when: [:each | each submorphs notEmpty ]! !

!Canvas methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/14/2014 06:51'!
gtInspectorFormIn: composite
	<gtInspectorPresentationOrder: 40>
	^ self form gtInspectorFormIn: composite ! !

!KMRepository class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/8/2014 15:17'!
gtExampleDefault
	<gtExample>
	^ self default! !

!KMRepository methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/20/2014 21:53'!
gtInspectorGlobalsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite table 
		title: 'Global keys';
		display: [ 
			self globalCategories
				flatCollect: [ :category | 
					category allEntries keymaps collect: [ :key | key -> category ] ]
				 ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		column: 'Shortcut' evaluated: [ :assoc | assoc key shortcut gtDisplayString ] width: 120;
		column: 'Description' evaluated: [ :assoc | assoc key description ];
		column: 'Action' evaluated: [ :assoc | assoc key action gtDisplayString ];
		column: 'Category' evaluated: [ :assoc | '' ] tags: [ :assoc | assoc value name ifNil: [ #() ] ifNotNil: [ { assoc value name }]];
		send: #key! !

!KMRepository methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/20/2014 21:52'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite table 
		title: 'Keys';
		display: [ 
			self categories values
				flatCollect: [ :category | 
					category allEntries keymaps collect: [ :key | key -> category ] ]
				 ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		column: 'Shortcut' evaluated: [ :assoc | assoc key shortcut gtDisplayString ] width: 120;
		column: 'Description' evaluated: [ :assoc | assoc key description ];
		column: 'Action' evaluated: [ :assoc | assoc key action gtDisplayString ];
		column: 'Category' evaluated: [ :assoc | '' ] tags: [ :assoc | assoc value name ifNil: [ #() ] ifNotNil: [ { assoc value name }]];
		send: #key! !

!ROMondrianViewBuilder methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/17/2013 19:30'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: 30>
	composite roassal 
		title: 'View';
		view: self! !

!GET2DiagramBuilder methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 5/18/2014 14:18'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'View';
		initializeView: [ self ]! !

!KMCategory methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/20/2014 08:20'!
gtDisplayOn: stream
	^ stream nextPutAll: self name asString! !

!KMCategory methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/9/2014 22:05'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Keys';
		display: [ self allEntries keymaps ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		format: #gtDisplayString;
		when: [ self allEntries keymaps notEmpty ]! !

!CPDiverging methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/25/2014 15:16'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 40>
	composite roassal2
		title: 'View';
		painting: [ :view | self viewOn: view ]! !

!RGMethodDefinition methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/19/2013 06:09'!
gtInspectorImplementorsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Implementors';
		display: [ self compiledMethod implementors ]! !

!RGMethodDefinition methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/19/2013 06:09'!
gtInspectorSendersIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Senders';
		display: [ self compiledMethod senders ]! !

!RGMethodDefinition methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/30/2013 22:19'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 20>
	^ composite smalltalkCode 
		title: 'Source';
		smalltalkClass: [ self methodClass ];
		display: [ self sourceCode ];
		act: [ :text | self methodClass compile: text text notifying: nil ]
			icon: GLMUIThemeExtraIcons glamorousAccept
			on: $s
			entitled: 'Accept';
		act: [ self browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			entitled: 'Browse'! !

!WindowModel methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/2/2013 16:31'!
gtInspectorModelNestingIn: composite
	self model gtInspectorModelNestingIn: composite! !

!GLMPresentation methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/4/2014 08:07'!
gtInspectorPanePortsIn: composite
	<gtInspectorPresentationOrder: 50>
	(self pane gtInspectorPortsIn: composite)
		title: 'Pane ports'! !

!GLMPane methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/4/2014 08:06'!
gtInspectorPortsIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: 'Ports';
		display: [ self ports ];
		column: 'Port' evaluated: [ :each | each name ];
		column: 'Value' evaluated: [ :each | each value asString ]! !

!CompiledMethod class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/29/2014 21:43'!
gtExampleSimple
	<gtExample>
	^ self class>>#gtExampleSimple! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/22/2013 07:54'!
gtDisplayOn: stream
	^ self printOn: stream! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 7/14/2014 10:52'!
gtInspectorASTIn: composite
	<gtInspectorPresentationOrder: 35> 
	(GTSimpleRBTreeBrowser new treeIn: composite)
		title: 'AST';
		display: [ :anObject | {anObject ast} ]
		! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 8/23/2011 07:30'!
gtInspectorBytecodeIn: composite
	<gtInspectorPresentationOrder: 40> 
	composite text 
		title: 'Bytecode';
		display: [:anObject | anObject symbolic ]! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 12/19/2013 16:33'!
gtInspectorIrIn: composite
	<gtInspectorPresentationOrder: 35> 
	composite text 
		title: 'Ir';
		display: [ :anObject || string |
				string := anObject ir longPrintString.
				string copyFrom: 2 to: string size ]! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 1/29/2014 17:56'!
gtInspectorPragmasIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite tabulator 
		title: 'Pragmas';
		when: [ :x | x pragmas notEmpty ];
		with: [ :t |  
			t row: #pragmas; row: #methods.
			t transmit to: #pragmas; andShow: [:a | 
				a list
					title: 'Pragmas';
					display: [ :method | method pragmas ];
					when: [ :x | x pragmas notEmpty ] ].
			t transmit from: #pragmas; to: #methods; andShow: [:a | 
				a list 
					title: 'Methods';
					display: [ :pragma | 
						| methods | 
						methods := OrderedCollection new.
						Object withAllSubclassesDo: [ :each | 
							methods addAll: ((Pragma allNamed: pragma keyword in: each) collect: #method) ].
						methods ];
					format: #selector ].
			t transmit
				toOutsidePort: #selection;
				from: #methods port: #selection
		];
		startOn: self! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/30/2013 22:15'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	^ composite smalltalkCode 
		title: 'Source';
		smalltalkClass: [ self methodClass ];
		display: [ self getSource ];
		act: [ self browse ] icon: GLMUIThemeExtraIcons glamorousBrowse entitled: 'Browse'! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/21/2013 23:29'!
gtInspectorVariableValuePairs
	| literalIndex |
	literalIndex := 0.
	^ Set new 
		add: ( 'header' -> self headerDescription );
		addAll: ( self literals collect: [ :aLiteral | 'literal', ( literalIndex := literalIndex + 1 ) asString -> aLiteral ] );
		add: ( 'all bytecodes' -> self symbolic );
		yourself
! !

!Symbol methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/19/2013 06:01'!
gtInspectorImplementorsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Implementors';
		display: [ self systemNavigation allImplementorsOf: self ];
		when: [ (self systemNavigation allImplementorsOf: self) notEmpty ];
		showOnly: 30! !

!Symbol methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/19/2013 06:01'!
gtInspectorSendersIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Senders';
		display: [ self systemNavigation allSendersOf: self ];
		when: [ (self systemNavigation allSendersOf: self) notEmpty ];
		showOnly: 30! !

!MessageTally class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 5/26/2014 07:57'!
on: aBlock
	"This utility method constructs a tally object and returns it without
	triggering the construction of the default report"
	^ MessageTally new
		spyEvery: 1
		on: aBlock;
		yourself ! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 14:05'!
children
	^ self sonsOver: 0! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 22:28'!
gtDisplayIdentifierOn: aStream
	class gtDisplayOn: aStream.
	self method methodClass ~~ class 
		ifTrue: [ aStream nextPut: $(; print: self method methodClass; nextPut: $) ].
	aStream 
		nextPutAll: '>>';
		store: self method selector! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 22:29'!
gtDisplayOn: aStream
	self gtDisplayIdentifierOn: aStream.
	aStream 
		nextPutAll: ' (';
		nextPutAll: self tally printString;
		nextPutAll: ')'! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 23:01'!
gtInspectorMessageTreeIn: composite
	<gtInspectorPresentationOrder: 40>
	| methods normalizer |
	methods := self withDeepCollect: #children.
	normalizer := RONColorLinearNormalizer 
						inContext: methods 
						withCommand: #tally 
						lowColor: Color gray 
						highColor: Color red.
	^ (composite tree)
		title: 'Tree';
		children: [ :each | each children ];
		"rootsExpanded;"
		format: [ :each | 
			Text 
				string: each gtDisplayString
				attributes: { TextColor color: (normalizer roValue: each)}];
		when: [ self children notEmpty ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		morphicSelectionAct: [ :list | GTUtils browseMethod: list selection method ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			on: $b
			entitled: 'Browse (b)'
		! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 21:36'!
gtInspectorPerformanceChartIn: composite
	<gtInspectorPresentationOrder: 40>
	| metric |
	metric := #localTally.
	^ composite graphET
		title: 'Top tallies';
		diagram: [ :renderer :presentation |
			GTInspectorMessageTallyCharter new 
				performanceOf: self 
				with: renderer 
				in: presentation ];
		when: [ self children notEmpty ]! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 14:10'!
gtInspectorReportIn: composite
	<gtInspectorPresentationOrder: 60>
	^ composite text
		title: 'Report';
		display: [ String streamContents: [:s | self report: s ] ]! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/4/2014 22:56'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 50>
	^ self method ifNotNil: [
		self method gtInspectorSourceIn: composite]! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 14:05'!
localTally
	^ self children 
		inject: self tally
		into: [ :diff :each | diff - each tally ]! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 14:05'!
localTime
	^ self children
		inject: self time 
		into: [ :diff :each | diff - each time ]! !

!Set methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 5/30/2012 06:49'!
gtInspectorItemsIn: composite
	"we override this because sets do not work well in morph tree morphs" 
	^ (super gtInspectorItemsIn: composite)
		display: [:set | set asOrderedCollection]! !

!CPQualitative methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/25/2014 15:16'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 40>
	composite roassal2
		title: 'View';
		painting: [ :view | self viewOn: view ]! !

!RTGraphBuilder methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/21/2014 21:33'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'View';
		initializeView: [ self ]! !

!NewValueHolder methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/18/2014 23:27'!
gtInspectorPresentationsIn: composite inContext: aGTInspector
	composite 
		updateOn: Announcement from: announcer.
	super gtInspectorPresentationsIn: composite inContext: aGTInspector! !

!ROView methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 9/6/2013 20:35'!
gtInspectorElementsHierarchyIn: composite
	<gtInspectorPresentationOrder: 20>
	composite tree 
		title: 'Elements';
		display: [ :each | {each} ];
		children: #elements! !

!ROView methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/17/2013 20:34'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: 30>
	composite roassal 
		title: 'View';
		initializeView: [self]! !

!KMDispatcher methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/1/2014 23:51'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite table 
		title: 'Keys';
		display: [ 
			((self targets collect: #category)
				add: self directKeymaps;
				yourself)
				flatCollect: [ :category | 
					category allEntries keymaps collect: [ :key | key -> category ] ]
				 ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		column: 'Shortcut' evaluated: [ :assoc | assoc key shortcut gtDisplayString ] width: 120;
		column: 'Description' evaluated: [ :assoc | assoc key description ];
		column: 'Action' evaluated: [ :assoc | assoc key action gtDisplayString ];
		column: 'Category' evaluated: [ :assoc | '' ] tags: [ :assoc | assoc value name ifNil: [ #() ] ifNotNil: [ { assoc value name }]];
		send: #key! !

!MethodContext methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/13/2013 06:44'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	self method gtInspectorSourceIn: composite! !

!RTMondrianViewBuilder methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/18/2014 22:43'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'View';
		initializeView: [ self ]! !

!Dictionary class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/25/2014 08:20'!
gtExampleSimple
	<gtExample>
	| dict |
	dict := Dictionary new.
	dict at: 4 put: 2.
	dict at: #fourty put: 'two'.
	^ dict! !

!Dictionary methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/28/2014 22:22'!
gtInspectorItemsIn: composite
	^ (composite table)
		title: [ :anObject | self size asString, ' items' ];
		display: [ self associations];
		column: 'Key' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each key ];
		column: 'Value' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each value ];
		selectionAct: [ :table |
			table rawSelection do: [ :assoc |
				self removeKey: assoc key ].
			table update ]
			entitled: 'Remove item(s)';
		selectionPopulate: #selection 
			entitled: 'Open key'
			with: [ :table |
				(table rawSelection collect: #key) gtInspectorInterestingObject ];
		beMultiple;
		withSmalltalkSearch;
		send: [ :selection | (selection notNil and: [selection size = 1]) 
				ifTrue: [selection anyOne value] 
				ifFalse: [selection collect: #value] ];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'! !

!Dictionary methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/21/2013 23:29'!
gtInspectorVariableValuePairs  
	^ Set new 
		add: ( 'tally' -> self size );
		add: ( 'array' -> self array );
		yourself
! !

!Date methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 8/13/2014 22:53'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite morph
		title: 'Preview';
		morph: [ CalendarMorph on: self ]! !

!CPSequential methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/25/2014 15:16'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 40>
	composite roassal2
		title: 'View';
		painting: [ :view | self viewOn: view ]! !

!GeneralScrollPane class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/20/2014 13:50'!
gtScrollerWithWrappingAndNoSpaceFilling
	"
	self gtScrollerWithWrappingAndNoSpaceFilling openInWindow
	"

	<gtExample>
	| scrollpane pane |
	scrollpane := GeneralScrollPane new.
	scrollpane changeScrollerTableLayout.
	pane := PanelMorph new
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself.
	scrollpane scrollTarget: pane.
	Object methods
		do: [ :each | 
			| methodLabel |
			methodLabel := each selector asTextMorph lock 
				backgroundColor: Color lightBlue.
				
			pane addMorph: methodLabel ].
	scrollpane
		hResizing: #shrinkWrap;
		height: 400.
	^ scrollpane! !

!GeneralScrollPane class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/20/2014 13:51'!
gtScrollerWithWrappingAndSpaceFilling
	"
	self gtScrollerWithWrappingAndSpaceFilling openInWindow
	"

	<gtExample>
	| scrollpane pane |
	scrollpane := GeneralScrollPane new.
	scrollpane changeScrollerTableLayout.
	pane := PanelMorph new
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself.
	scrollpane scrollTarget: pane.
	Object methods
		do: [ :each | 
			| methodLabel |
			methodLabel := Morph new
				changeTableLayout;
				wrapCentering: #center;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				color: Color lightBlue.
			methodLabel addMorphBack: (each selector asTextMorph lock).
				
			pane addMorph: methodLabel ].
	scrollpane
		hResizing: #shrinkWrap;
		height: 400.
	^ scrollpane! !

!Color methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/18/2013 11:46'!
gtInspectorColorIn: composite
	<gtInspectorPresentationOrder: 30>
	composite morph 
		title: 'Color';
		display: [ BorderedMorph new color: self ]! !

!Text methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/21/2013 22:45'!
gtInspectorItemsIn: composite
	"No items presentation for a Text"! !

!Text methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 8/13/2014 23:30'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: -10>  
	 composite text
		title: 'Text';
		format: self! !

!Collection methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/21/2013 23:21'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ (composite list)
		title: [ :anObject | anObject size asString, ' items' ];
		display: [ :aCollection | self ];
		beMultiple;
		withSmalltalkSearch;		
		format: [ :each | GTObjectPrinter new asTruncatedTextFrom: each ];
		send: [ :result | (result notNil and: [result size = 1]) 
				ifTrue: [result anyOne] 
				ifFalse: [self species withAll: result]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

!GLMSystemWindow methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/18/2013 05:26'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ (self model 
		gtInspectorOpenTreeIn: composite)
		title: 'Browser tree'! !

!KMKeymap methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/10/2014 07:07'!
gtDisplayOn: aStream
	aStream 
		nextPutAll: self name gtDisplayString;
		nextPutAll: ' on ';
		nextPutAll: self shortcut gtDisplayString;
		nextPutAll: ' do ' ;
		nextPutAll: self action gtDisplayString! !

!KMKeymap methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/20/2014 22:11'!
gtInspectorSourceCodeIn: composite
	<gtInspectorPresentationOrder: 30> 

	^ self action gtInspectorSourceCodeIn: composite! !

!GLMCompositePresentation methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/18/2013 05:46'!
gtInspectorBrowserIn: composite
	<gtInspectorPresentationOrder: 40>  
	^ (composite wrapper with: [ :w |
		w title: 'Live'.
		w show: [:a | a custom: self copy ] ]
		) startOn: self entity! !

!GLMCompositePresentation methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/17/2013 16:18'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ composite roassal 
		title: 'Tree';
		painting: [:view :b | 
			self viewTreeOn: view ]! !

GLMCompositePresentation subclass: #GTInspectorMessageTallyCharter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Core'!

!GTInspectorMessageTallyCharter commentStamp: 'TudorGirba 1/18/2014 14:28' prior: 0!
Helper class for displaying charts specific for a MessageTally.!

!GTInspectorMessageTallyCharter methodsFor: 'visualization' stamp: 'TudorGirba 1/18/2014 14:30'!
nestingMapOf: aMessageTally on: view
	"This is provides a treemap visualization of a message tally"
		
	| builder methods methodNestings |
	builder := ROTreeMapBuilder new.
	builder weightBlock: [ :el | el children size max: 1 ].
	methods := OrderedCollection new.
	methodNestings := OrderedCollection new.
	aMessageTally 
		deep: #children
		do: [ :each | methods add: each ]
		relationDo: [ :from :to | methodNestings add: from->to ].
	builder nodes: methods.
	builder nestingFromAssociations: methodNestings.
	builder fillNodes: [:x | true] withColor: (RONColorLinearNormalizer inContext: methods withCommand: [:m | (m isKindOf: ROElement) ifTrue: [ m model localTally ] ifFalse: [m localTally] ]  lowColor: Color white highColor: Color red ).
	builder withShadedFrames.
	builder drawOn: view raw! !

!GTInspectorMessageTallyCharter methodsFor: 'visualization' stamp: 'TudorGirba 1/18/2014 22:30'!
performanceOf: aMessageTally with: renderer in: presentation
	"Displays a Graph-ET chart showing the top 20 most costly methods within a MessageTally.
	For each method it sows the number of occurences of a method and the 
	total amount of local tallies for that method. Useful for identifying outliers 
	within one execution."
	
	| all diag diag2 grouped metric |
	metric := #localTally.
	all := aMessageTally deepCollect: [ :each | each sonsOver: 1 ].
	grouped := (all groupedBy: [ :each | String streamContents: [:s | each gtDisplayIdentifierOn: s] ]) 
						associations sorted: [:a :b | 
									(a value sumNumbers: metric) > 
									(b value sumNumbers: metric) ].
	grouped := (grouped first: (20 min: grouped size)) select: [:each | (each value sumNumbers: metric) > 0].
	diag := (GETHorizontalBarDiagram new)
		xAxisLabel: 'Locations';
		modelLabels: [:each | each key ];
		x: [:each | each value size];
		valueAxis;
		color: Color veryLightGray;
		axisColor: Color veryLightGray;
		on: ROMouseClick do: [:event | presentation selection: event model value ];
		models: grouped.
	diag2 := (GETHorizontalBarDiagram new)
		xAxisLabel: 'Tallies';
		x: [:each | each value sumNumbers: metric];
		regularAxis;
		xAxisOnTop;
		gapFraction: 1 / 2;
		color: (Color red);
		axisColor: (Color red);
		on: ROMouseClick do: [:event | presentation selection: event model value ];
		models: grouped.
	(renderer unionDiagram)
		add: diag;
		add: diag2! !

!Float methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/21/2013 23:13'!
gtInspectorVariableValuePairs
	"We override the default variables to add significand and exponent"
	| bindings |
	bindings := super gtInspectorVariableValuePairs.
	bindings
		add: 'significand' -> self significand;
		add: 'exponent' -> self exponent.
	^ bindings! !

!RTView methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/18/2014 07:47'!
gtInspectorElementsHierarchyIn: composite
	<gtInspectorPresentationOrder: 20>
	composite list 
		title: 'Elements';
		display: [ :each | each elements ]! !

!RTView methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AlexandreBergel 3/31/2014 14:24'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'View';
		initializeView: [ self ]
		! !

!ReadStream methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/18/2013 13:00'!
gtInspectorStreamStateIn: composite
	<gtInspectorPresentationOrder: 50>
	(composite wrapper with: [ :w | 
		w title: 'Contents'.
		w show: [ :a | 
			a text
				display: [ self contents ];
				initialize: [ :aPresentation | 
					aPresentation selectionInterval: (1 to: self position) ] ] ])
		startOn: self! !

!Form methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/14/2014 06:51'!
gtInspectorFormIn: composite
	<gtInspectorPresentationOrder: 90>  
	^ composite morph 
		title: 'Morph';
		display: [ self asMorph ]! !

!BlockClosure methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/23/2014 15:32'!
gtInspectorSourceCodeIn: composite 
	<gtInspectorPresentationOrder: 40>
	self sourceNode gtInspectorSourceCodeIn: composite! !

!Integer methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/21/2013 23:13'!
gtInspectorVariableValuePairs
	"We override the default variables to add representations for various bases"
	^ super gtInspectorVariableValuePairs
		add: 'hex' -> self printStringHex;
		add: 'octal' -> (self printStringBase: 8);
		add: 'binary' -> (self printStringBase: 2);
		yourself! !

!SmallDictionary methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/1/2012 22:10'!
gtInspectorItemsIn: composite
	"we override this because sets do not work well in morph tree morphs" 
	^ (super gtInspectorItemsIn: composite)
		display: [:smallDictionary  | smallDictionary associations asOrderedCollection]! !

!TraitDescription methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/4/2013 10:51'!
gtInspectorUsersIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 	
		title: 'Users';
		display: [ 
			Smalltalk allClasses select: [ :class |
			   class traitComposition traits includes: self ] ]! !

!Array class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/24/2014 15:15'!
gtExample
	<gtExample>
	^ #(42 42.0 #fourtytwo 'fourtytwo')! !

!RBProgramNode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/20/2014 22:19'!
gtInspectorSourceCodeIn: composite
	<gtInspectorPresentationOrder: 30> 

	^ composite smalltalkCode 
		title: 'Source code';
		display: [ self source ];
		smalltalkClass: [ self parents first methodClass ]; 
		initialize: [ :presentation | 
			presentation selectionInterval: self sourceInterval ];
		act: [ self method compiledMethod browse ] icon: GLMUIThemeExtraIcons glamorousBrowse entitled: 'Browse'! !

!RBProgramNode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 7/14/2014 10:29'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 30> 
	^ (GTSimpleRBTreeBrowser new treeIn: composite)
		title: 'Tree'! !

!Announcer methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/20/2014 12:09'!
gtInspectorAnnouncementsIn: composite
	<gtInspectorPresentationOrder: 40>
	| recordedAnnouncements |
	recordedAnnouncements := CollectionValueHolder value: OrderedCollection new.
	self when: Announcement do: [ :ann | recordedAnnouncements addFirst: DateAndTime now -> ann ].
	composite table
		title: 'Announcements';
		display: [ recordedAnnouncements value ];
		column: 'Time' evaluated: #key;
		column: 'Announcement' evaluated: #value;
		send: #value;
		showOnly: 50;
		format: #gtDisplayString;
		updateOn: Announcement from: recordedAnnouncements announcer;
		act: [ :table | 
			recordedAnnouncements := OrderedCollection new.
			table update ] 
			icon: GLMUIThemeExtraIcons glamorousCancel 
			entitled: 'Reset'! !

!Announcer methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/8/2014 23:34'!
gtInspectorSubscriptionsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite table
		title: 'Subscriptions';
		display: [ self subscriptions glmSubscriptions ];
		when: [ self numberOfSubscriptions isZero not ];
		column: 'Subscriber' evaluated: [ :each | each subscriber asString ];
		column: 'Announcement' evaluated: [ :each | each announcementClass name ];
		column: 'Kind' evaluated: [ :each | each class name ];
		act: [ :table | 
			self subscriptions reset.
			table update ] icon: GLMUIThemeExtraIcons glamorousCancel entitled: 'Reset';
		selectionAct: [ :table | 
			self subscriptions remove: table selection.
			table update ] entitled: 'Remove subscription'! !

!GLMBrowser methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/18/2013 05:46'!
gtInspectorBrowserIn: composite
	<gtInspectorPresentationOrder: 40>  
	^ (composite wrapper with: [ :w |
		w title: 'Live'.
		w show: [:a | a custom: self copy ] ]
		) startOn: self entity! !

!GLMBrowser methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/18/2013 05:26'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ composite roassal 
		title: 'Tree';
		painting: [:view :b | 
			self viewTreeOn: view ]! !

!Class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/11/2014 23:05'!
gtInspectorCommentIn: composite
	"This provides an editable comment of the current class"
	<gtInspectorPresentationOrder: 20>
	composite text 
		title: 'Comment';
		display: [ self comment ];
		act: [ :text | 
			self comment: text text ]
			icon: GLMUIThemeExtraIcons glamorousAccept 
			on: $s
			entitled: 'Accept'! !

!Class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 3/9/2014 09:01'!
gtInspectorMethodsIn: composite
	"This provides a list of all methods provided by the current class"
	<gtInspectorPresentationOrder: 20>
	composite list 
		title: 'Methods';
		display: [ (self allMethods collect: #asRingDefinition) 
						sorted: [ :x :y | x selector < y selector ] ];
		format: #selector;
		tags: [ :each | {each methodClass name} ]! !

!ByteArray class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/24/2014 15:12'!
gtExampleSimple
	<gtExample>
	^ #[2r1010 8r333 16rFF]! !

!ByteArray methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/21/2013 22:44'!
gtInspectorItemsIn: composite
	"No items presentation for a ByteArray"! !

!SequenceableCollection methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/30/2013 15:03'!
gtInspectorItemsIn: composite
	^ composite table
		title: [ :anObject | anObject size asString, ' items' ];
		display: [ :aCollection | (1 to: self size) collect: [ :index | index -> (self at: index) ] ];
		beMultiple;
		searchOn: [:text :each | 
			Compiler evaluate: ' | entity each | each := self. entity := each.', text for: each value logged: false];
		column: 'Item' evaluated: [ :assoc | GTObjectPrinter new asTruncatedTextFrom: assoc value ];
		column: 'Index' evaluated: [ :assoc | assoc key asString ];
		send: [ :result | 
			result isNil
				ifTrue: [ nil ]
				ifFalse: [ result value size = 1 
					ifTrue: [result anyOne value]  
					ifFalse: [self species withAll: (result collect: [:each | each value])]]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

!Pragma class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 10/4/2013 22:16'!
gtInspectorAnnotatedMethodsIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite table 
		title: 'All';
		showOnly: 50;
		withSmalltalkSearch;
		display: [:anObject | 
			| pragmas |
			pragmas := OrderedCollection new.
			Object withAllSubclassesDo: [:each |
				Pragma withPragmasIn: each do: [:p |
					pragmas add: p]].
			(pragmas groupedBy: #keyword) associations sorted: [ :a :b | 
				a key < b key ]
		];
		column: 'Keyword' evaluated: [ :each | each key ];
		column: 'Instances' evaluated: [ :each | each value size asString ];
		send: #value! !

!Pragma methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 10/6/2013 22:09'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	self method gtInspectorSourceIn: composite! !

!ZnMessage methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/16/2013 22:17'!
gtInspectorHeadersIn: composite 
	<gtInspectorPresentationOrder: 30>
	^ (self headers headers gtInspectorItemsIn: composite) 
		display: [:anObject | self headers headers associations ];
		title: [:anObject | self headers headers size asString , ' header items' ]! !
